# Terror

Terror is a terrible solution to the non-problem of creating custom error
classes in Ruby. Terror provides a DSL to define custom error classes with
support for custom messages, parent classes, and custom behavior. If that still
seems like too much work, Terror will automagically create error classes for
you at runtime if the class name ends with "Error".

Terror was written years ago before I knew how terrible of an idea it was. I'm
only updating it now because the older version was even more awful. Don't be
lazy. Don't write code like this.

## Installation

Add this line to your application's Gemfile:

```ruby
gem "terror"
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install terror

## Usage

```ruby
require "terror"
class MyClass
  extend Terror

  # Error base class can be specified in the keyword argument `from`.
  errors from: RuntimeError do
    # Errors can use the `message` keyword to set a custom error message.
    MyError message: "just another error"

    # Override the top-level base class for this error.
    SpecialError from: StandardError
  end

  def raise_error
    # This error does not exist before it is raised here.
    raise TooLazyToDefineThisError, "error gets defined at runtime"
  end
end
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake test` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/adamtanner/terror.

## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).

